package Component;

/**
 * Created by ztest on 2020/6/12
 */

import java.io.File;

import org.apache.camel.Endpoint;
import org.apache.camel.Exchange;
import org.apache.camel.impl.DefaultProducer;
import org.apache.commons.io.FileUtils;

public class MyFileProducer extends DefaultProducer {
    private File outputDir;

    public MyFileProducer(Endpoint endpoint) {
        super(endpoint);

        this.outputDir = new File(endpoint.getEndpointUri().substring(endpoint.getEndpointUri().indexOf(":") + 1));
    }

    public void process(Exchange exchange) throws Exception {
        File file = exchange.getIn().getBody(File.class);
        if (file != null) {
            FileUtils.moveFileToDirectory(file, outputDir, true);
        }
    }

}
