package Router;

import Bean.HelloBean;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * test
 */
public class InvokeWithProcessorSpringRoute extends RouteBuilder {
    @Autowired
    private HelloBean hello;

    @Override
    public void configure() throws Exception {
        from("jetty:http://127.0.0.1:8282/xStartFlow")
                .process(new Processor() {
                    public void process(Exchange exchange) throws Exception {
                        String name = exchange.getIn().getBody(String.class);
                        //HelloBean helloBean1 = new HelloBean();
                        String answer = hello.hello(name);
                        exchange.getOut().setBody(answer);
                    }
                });
    }
}
